#!/usr/bin/python3.3
###################################################
#Ce fichier contient la correction de l'exercice 9#
#Créé par : Wolf                                  #
#wolf@bad-wolf.fr   blog.bad-wolf.fr              #
###################################################

class Animal(object):
    """
    definit un animal
    """
    
    def __init__(self,nom,espece="",age=1):
        """
        init tout les éléments du chien
        """
        self.nom = nom
        self.__espece = espece #le nom de l'éspece n'a pas besoin d'être accessible par la class fille
        self._age = age
        self._faim = 0.5        #0=mort de faim 1=rassasié
        self._soif = 0.5        #0=mort de soif 1=hydraté
        self._fatigue = 0.5      #0=endormi 1=reposé

    def manger(self):           #tous les animaux doivent manger
        """
        fait manger l'animal
        """
        print("Je suis rassasié")
        self._faim = 1
    
    def boire(self):            #tous doivent boire
        """
        fait boire l'animal
        """
        print("je n'ai plus soif")
        self._soif = 1
        
    def dormir(self):           #tous dorment
        """
        fait dormir l'animal
        """
        print("je suis en pleine forme")
        self._fatigue = 1

class Chien(Animal):            #on definit un chien, qui est une sort d'animal
    """
    definit un chien
    """
    
    def __init__(self, nom, race="Berger Australien", age=1):
        """
        initialise le chien
        """        
        Animal.__init__(self,nom,espece="chien",age=age) #on utilise le contructeur de Animal
        self.race = race
        
    def manger(self):           #méthode surchargé
        """
        le chien mange d'une maniére particuliére
        """
        print("Je mange de la viande")
        Animal.manger(self)     #on aimais bien l'autre methode, donc on l'utilise quand même

    def dormir(self):
        """
        fait dormir le chien
        """
        print("Je ne dort que d'un oeil")       #il n'est pas obligatoir d'utiliser la méthode de la class mére
        print("Je suis reposé")
        self._fatigue = 1
        
    #le chien boit comme les autres animaux, on ne surcharge pas la méthode boire
        
    #les méthodes suivantes sont propre au chien
    
    def aboyer(self):           #tous les animaux n'aboient pas
        """
        fait aboyer le chien
        """
        print("Wouaf Wouaf")

    def garder(self):           #seul les chiens montent la garde
        """
        fait monter la garder au chien
        """
        estOk = True
        if self._fatigue<0.25:
            if estOk:
                print("Je suis",end=" ")
            print("trop fatigué",end="")
            estOk = False
        if self._faim<0.25:
            if estOk:
                print("Je suis",end=" ")
            else:
                print(",",end=" ")
            print("trop affamé",end="")
            estOk = False
        if self._soif<0.25:
            if estOk:
                print("Je suis",end=" ")
            else:
                print(",",end=" ")
            print("trop assoiffé",end="")
            estOk = False
        if estOk:
            print("je monte la garde")
            self._fatigue-=0.1
            self._faim-=0.1
            self._soif-=0.1
            return True
        else:
            print(" pour monter la garde")
            return False
            
    def mordre(self):       #certains animaux ne mordent pas
        """
        fait mordre le chien
        """
        if self._fatigue<0.25:
            print("Je suis trop fatigué pour mordre")
            return False
        else:
            print("je mord !!!")
            return True

animal = Animal("Claude")   #on créer un objet de type Animal
chien = Chien("George")     #on créer un objet de type Chien
print(animal.__dict__)      #on affiche leurs attribut, notez les _Animal__espece : c'est l'attribut espece accessible uniquement pas animal, ainsi chien ne peut y acceder
print(chien.__dict__)
print("animal est Animal :",isinstance(animal,Animal),", animal est Chien :",isinstance(animal,Chien))      #animal est un Animal mais pas un chiens    
print("chien est Animal :",isinstance(chien,Animal),", chien est Chien :",isinstance(chien,Chien))          #chien est un Chien et donc un Animal









